(define-module (hello))

(define GREETING_PREFIX "Hello ")
(define GREETING_SUFFIX "!\n")
(define DEFAULT_NAME "world")

(define-public hi
  "Says hello to the named person"
  (lambda* (#:optional name)
    (string-append GREETING_PREFIX (addressee name) GREETING_SUFFIX)))

(define addressee
  (lambda (name)
    (if name
        name
        DEFAULT_NAME)))
